# std::atomic::is_lock_free

From cppreference.com
< cpp‎ | atomic‎ | atomic

|  | (since C++11)
bool is_lock_free() const; |  |
bool is_lock_free() const volatile; |  |

Checks whether the atomic operations on all objects of this type are lock-free.

### Parameters

(none)

### Return value

true if the atomic operations on the objects of this type are lock-free, false otherwise.

### Notes

All atomic types except for std::atomic_flag may be implemented using mutexes or other locking operations, rather than using the lock-free atomic CPU instructions. Atomic types are also allowed to be sometimes lock-free, e.g. if only aligned memory accesses are naturally atomic on a given architecture, misaligned objects of the same type have to use locks.

The C++ standard recommends (but does not require) that lock-free atomic operations are also address-free, that is, suitable for communication between processes using shared memory.

### Exceptions

`noexcept` specification:
noexcept

### Example

Run this code

    #include <iostream>
    #include <utility>
    #include <atomic>

    struct A { int a[100]; };
    struct B { int x, y; };
    int main()
    {
        std::cout << std::boolalpha
                  << "std::atomic<A> is lock free? "
                  << std::atomic<A>{}.is_lock_free() << '\n'
                  << "std::atomic<B> is lock free? "
                  << std::atomic<B>{}.is_lock_free() << '\n';
    }

Possible output:

    std::atomic<A> is lock free? false
    std::atomic<B> is lock free? true

### See also

atomic_is_lock_free (C++11) | checks if the atomic type's operations are lock-free (function template)
is_always_lock_free [static] (C++17) | indicates that the type is always lock-free (public static member constant)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/atomic/atomic/is_lock_free&oldid=91385"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template